﻿using System;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Core;
using System.Threading;
using System.Windows.Forms;


namespace WindowsFormsApplication43
{
    public delegate void SetMapExtent(RectangleShape rect);
    public partial class Form1 : Form
    {
        private Random rand = new Random();
        Thread thread;
        public Form1()
        {
            InitializeComponent();
            ThreadStart start = new ThreadStart(FreePan);
            thread = new Thread(start);
        }

        private void FreePan()
        {
            int startTime = 1;
            int endTime = 1;
            while (true)
            {
                if ((endTime - startTime) == 15000)
                {
                    startTime = endTime;
                    int minX = rand.Next(-20037508, 0);
                    int maxX = rand.Next(0, 20037508);
                    int minY = rand.Next(-20037508, 0);
                    int maxY = rand.Next(0, 20037508);
                    SetMapExtent setExtent = new SetMapExtent(SetCurrentExtent);
                    this.Invoke(setExtent, new RectangleShape(minX, maxY, maxX, minY));
                    //setExtent.Invoke(new RectangleShape(minX, maxY, maxX, minY));
                }
                endTime += 1;
            }
        }

        private void SetCurrentExtent(RectangleShape rect)
        {
            winformsMap1.CurrentExtent = rect;
            winformsMap1.Refresh();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.CurrentExtent = new RectangleShape(-20037508.352, 20037508.352, 20037508.352, -20037508.352);
            OpenStreetMapLayer openStreetLayer = new OpenStreetMapLayer();
            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(openStreetLayer);

            //GdiPlusGeoCanvas geoCanvas = new GdiPlusGeoCanvas();
            //Bitmap bitmap = new Bitmap(winformsMap1.Width, winformsMap1.Height);
            //openStreetLayer.Open();
            //geoCanvas.BeginDrawing(bitmap, winformsMap1.CurrentExtent, GeographyUnit.Meter);
            //openStreetLayer.Draw(geoCanvas, new Collection<SimpleCandidate>());
            //geoCanvas.EndDrawing();
            //bitmap.Save("1.jpg");
            //winformsMap1.Overlays.Add(wmsOverlay);
            winformsMap1.Overlays.Add(overlay);
            winformsMap1.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            thread.Start();
        }
    }
}
